Index: src/wp-includes/js/customize-preview-nav-menus.js
===================================================================
--- src/wp-includes/js/customize-preview-nav-menus.js	(revision 0)
+++ src/wp-includes/js/customize-preview-nav-menus.js	(working copy)
@@ -0,0 +1,242 @@
+/*global jQuery, JSON, _wpCustomizePreviewNavMenusExports, _ */
+
+wp.customize.menusPreview = ( function( $, api ) {
+	'use strict';
+	var self;
+
+	self = {
+		renderQueryVar: null,
+		renderNonceValue: null,
+		renderNoncePostKey: null,
+		previewCustomizeNonce: null,
+		previewReady: $.Deferred(),
+		requestUri: '/',
+		theme: {
+			active: false,
+			stylesheet: ''
+		},
+		navMenuInstanceArgs: {},
+		refreshDebounceDelay: 200
+	};
+
+	api.bind( 'preview-ready', function() {
+		self.previewReady.resolve();
+	} );
+	self.previewReady.done( function() {
+		self.init();
+	} );
+
+	/**
+	 * Bootstrap functionality.
+	 */
+	self.init = function() {
+		var self = this;
+
+		if ( 'undefined' !== typeof _wpCustomizePreviewNavMenusExports ) {
+			$.extend( self, _wpCustomizePreviewNavMenusExports );
+		}
+
+		self.previewReady.done( function() {
+			api.each( function( setting, id ) {
+				setting.id = id;
+				self.bindListener( setting );
+			} );
+
+			api.preview.bind( 'setting', function( args ) {
+				var id, value, setting;
+				args = args.slice();
+				id = args.shift();
+				value = args.shift();
+				if ( ! api.has( id ) ) {
+					// Currently customize-preview.js is not creating settings for dynamically-created settings in the pane; so we have to do it
+					setting = api.create( id, value ); // @todo This should be in core
+					setting.id = id;
+					if ( self.bindListener( setting ) ) {
+						setting.callbacks.fireWith( setting, [ setting(), setting() ] );
+					}
+				}
+			} );
+		} );
+	};
+
+	/**
+	 *
+	 * @param {wp.customize.Value} setting
+	 * @returns {boolean} Whether the setting was bound.
+	 */
+	self.bindListener = function( setting ) {
+		var matches, themeLocation;
+
+		matches = setting.id.match( /^nav_menu\[(-?\d+)]$/ );
+		if ( matches ) {
+			setting.navMenuId = parseInt( matches[1], 10 );
+			setting.bind( self.onChangeNavMenuSetting );
+			return true;
+		}
+
+		matches = setting.id.match( /^nav_menu_item\[(-?\d+)]$/ );
+		if ( matches ) {
+			setting.navMenuItemId = parseInt( matches[1], 10 );
+			setting.bind( self.onChangeNavMenuItemSetting );
+			return true;
+		}
+
+		matches = setting.id.match( /^nav_menu_locations\[(.+?)]/ );
+		if ( matches ) {
+			themeLocation = matches[1];
+			setting.bind( function() {
+				self.refreshMenuLocation( themeLocation );
+			} );
+			return true;
+		}
+
+		return false;
+	};
+
+	/**
+	 * Handle changing of a nav_menu setting.
+	 *
+	 * @this {wp.customize.Setting}
+	 */
+	self.onChangeNavMenuSetting = function() {
+		var setting = this;
+		if ( ! setting.navMenuId ) {
+			throw new Error( 'Expected navMenuId property to be set.' );
+		}
+		self.refreshMenu( setting.navMenuId );
+	};
+
+	/**
+	 * Handle changing of a nav_menu_item setting.
+	 *
+	 * @this {wp.customize.Setting}
+	 * @param {object} to
+	 * @param {object} from
+	 */
+	self.onChangeNavMenuItemSetting = function( to, from ) {
+		if ( from && from.nav_menu_term_id && ( ! to || from.nav_menu_term_id !== to.nav_menu_term_id ) ) {
+			self.refreshMenu( from.nav_menu_term_id );
+		}
+		if ( to && to.nav_menu_term_id ) {
+			self.refreshMenu( to.nav_menu_term_id );
+		}
+	};
+
+	/**
+	 * Update a given menu rendered in the preview.
+	 *
+	 * @param {int} menuId
+	 */
+	self.refreshMenu = function( menuId ) {
+		var self = this, assignedLocations = [];
+
+		api.each(function( setting, id ) {
+			var matches = id.match( /^nav_menu_locations\[(.+?)]/ );
+			if ( matches && menuId === setting() ) {
+				assignedLocations.push( matches[1] );
+			}
+		});
+
+		_.each( self.navMenuInstanceArgs, function( navMenuArgs, instanceNumber ) {
+			if ( menuId === navMenuArgs.menu || -1 !== _.indexOf( assignedLocations, navMenuArgs.theme_location ) ) {
+				self.refreshMenuInstanceDebounced( instanceNumber );
+			}
+		} );
+	};
+
+	self.refreshMenuLocation = function( location ) {
+		var foundInstance = false;
+		_.each( self.navMenuInstanceArgs, function( navMenuArgs, instanceNumber ) {
+			if ( location === navMenuArgs.theme_location ) {
+				self.refreshMenuInstanceDebounced( instanceNumber );
+				foundInstance = true;
+			}
+		} );
+		if ( ! foundInstance ) {
+			api.preview.send( 'refresh' );
+		}
+	};
+
+	/**
+	 * Update a specific instance of a given menu on the page.
+	 *
+	 * @param {int} instanceNumber
+	 */
+	self.refreshMenuInstance = function( instanceNumber ) {
+		var self = this, data, customized, container, request, wpNavArgs, instance;
+
+		if ( ! self.navMenuInstanceArgs[ instanceNumber ] ) {
+			throw new Error( 'unknown_instance_number' );
+		}
+		instance = self.navMenuInstanceArgs[ instanceNumber ];
+
+		container = $( '#partial-refresh-menu-container-' + String( instanceNumber ) );
+
+		if ( ! instance.can_partial_refresh || 0 === container.length ) {
+			api.preview.send( 'refresh' );
+			return;
+		}
+
+		data = {
+			nonce: self.previewCustomizeNonce, // for Customize Preview
+			wp_customize: 'on'
+		};
+		if ( ! self.theme.active ) {
+			data.theme = self.theme.stylesheet;
+		}
+		data[ self.renderQueryVar ] = '1';
+		customized = {};
+		api.each( function( setting, id ) {
+			// @todo We need to limit this to just the menu items that are associated with this menu/location.
+			if ( /^(nav_menu|nav_menu_locations)/.test( id ) ) {
+				customized[ id ] = setting.get();
+			}
+		} );
+		data.customized = JSON.stringify( customized );
+		data[ self.renderNoncePostKey ] = self.renderNonceValue;
+
+		wpNavArgs = $.extend( {}, instance );
+		data.wp_nav_menu_args_hash = wpNavArgs.args_hash;
+		delete wpNavArgs.args_hash;
+		data.wp_nav_menu_args = JSON.stringify( wpNavArgs );
+
+		container.addClass( 'customize-partial-refreshing' );
+
+		request = wp.ajax.send( null, {
+			data: data,
+			url: self.requestUri
+		} );
+		request.done( function( data ) {
+			var eventParam;
+			container.empty().append( $( data ) );
+			eventParam = {
+				instanceNumber: instanceNumber,
+				wpNavArgs: wpNavArgs
+			};
+			$( document ).trigger( 'customize-preview-menu-refreshed', [ eventParam ] );
+		} );
+		request.fail( function() {
+			// @todo provide some indication for why
+		} );
+		request.always( function() {
+			container.removeClass( 'customize-partial-refreshing' );
+		} );
+	};
+
+	self.currentRefreshMenuInstanceDebouncedCalls = {};
+
+	self.refreshMenuInstanceDebounced = function( instanceNumber ) {
+		if ( self.currentRefreshMenuInstanceDebouncedCalls[ instanceNumber ] ) {
+			clearTimeout( self.currentRefreshMenuInstanceDebouncedCalls[ instanceNumber ] );
+		}
+		self.currentRefreshMenuInstanceDebouncedCalls[ instanceNumber ] = setTimeout(
+			function() {
+				self.refreshMenuInstance( instanceNumber );
+			},
+			self.refreshDebounceDelay
+		);
+	};
+
+	return self;
+
+}( jQuery, wp.customize ) );
Index: src/wp-includes/script-loader.php
===================================================================
--- src/wp-includes/script-loader.php	(revision 32796)
+++ src/wp-includes/script-loader.php	(working copy)
@@ -406,6 +406,9 @@
 	$scripts->add( 'customize-widgets', "/wp-admin/js/customize-widgets$suffix.js", array( 'jquery', 'jquery-ui-sortable', 'jquery-ui-droppable', 'wp-backbone', 'customize-controls' ), false, 1 );
 	$scripts->add( 'customize-preview-widgets', "/wp-includes/js/customize-preview-widgets$suffix.js", array( 'jquery', 'wp-util', 'customize-preview' ), false, 1 );
 
+	$scripts->add( 'customize-nav-menus', "/wp-admin/js/customize-nav-menus$suffix.js", array( 'jquery', 'wp-backbone', 'customize-controls', 'accordion', 'nav-menu', 'wp-a11y' ), false, 1 );
+	$scripts->add( 'customize-preview-nav-menus', "/wp-includes/js/customize-preview-nav-menus$suffix.js", array( 'jquery', 'wp-util', 'customize-preview' ), false, 1 );
+
 	$scripts->add( 'accordion', "/wp-admin/js/accordion$suffix.js", array( 'jquery' ), false, 1 );
 
 	$scripts->add( 'shortcode', "/wp-includes/js/shortcode$suffix.js", array( 'underscore' ), false, 1 );
@@ -656,15 +659,16 @@
 	$suffix = SCRIPT_DEBUG ? '' : '.min';
 
 	// Admin CSS
-	$styles->add( 'wp-admin',           "/wp-admin/css/wp-admin$suffix.css", array( 'open-sans', 'dashicons' ) );
-	$styles->add( 'login',              "/wp-admin/css/login$suffix.css", array( 'buttons', 'open-sans', 'dashicons' ) );
-	$styles->add( 'install',            "/wp-admin/css/install$suffix.css", array( 'buttons', 'open-sans' ) );
-	$styles->add( 'wp-color-picker',    "/wp-admin/css/color-picker$suffix.css" );
-	$styles->add( 'customize-controls', "/wp-admin/css/customize-controls$suffix.css", array( 'wp-admin', 'colors', 'ie', 'imgareaselect' ) );
-	$styles->add( 'customize-widgets',  "/wp-admin/css/customize-widgets$suffix.css", array( 'wp-admin', 'colors' ) );
-	$styles->add( 'press-this',         "/wp-admin/css/press-this$suffix.css", array( 'open-sans', 'buttons' ) );
+	$styles->add( 'wp-admin',            "/wp-admin/css/wp-admin$suffix.css", array( 'open-sans', 'dashicons' ) );
+	$styles->add( 'login',               "/wp-admin/css/login$suffix.css", array( 'buttons', 'open-sans', 'dashicons' ) );
+	$styles->add( 'install',             "/wp-admin/css/install$suffix.css", array( 'buttons', 'open-sans' ) );
+	$styles->add( 'wp-color-picker',     "/wp-admin/css/color-picker$suffix.css" );
+	$styles->add( 'customize-controls',  "/wp-admin/css/customize-controls$suffix.css", array( 'wp-admin', 'colors', 'ie', 'imgareaselect' ) );
+	$styles->add( 'customize-widgets',   "/wp-admin/css/customize-widgets$suffix.css", array( 'wp-admin', 'colors' ) );
+	$styles->add( 'customize-nav-menus', "/wp-admin/css/customize-nav-menus$suffix.css", array( 'wp-admin', 'colors' ) );
+	$styles->add( 'press-this',          "/wp-admin/css/press-this$suffix.css", array( 'open-sans', 'buttons' ) );
 
-	$styles->add( 'ie',                 "/wp-admin/css/ie$suffix.css" );
+	$styles->add( 'ie', "/wp-admin/css/ie$suffix.css" );
 	$styles->add_data( 'ie', 'conditional', 'lte IE 7' );
 
 	// Common dependencies
@@ -673,11 +677,12 @@
 	$styles->add( 'open-sans', $open_sans_font_url );
 
 	// Includes CSS
-	$styles->add( 'admin-bar',      "/wp-includes/css/admin-bar$suffix.css", array( 'open-sans', 'dashicons' ) );
-	$styles->add( 'wp-auth-check',  "/wp-includes/css/wp-auth-check$suffix.css", array( 'dashicons' ) );
-	$styles->add( 'editor-buttons', "/wp-includes/css/editor$suffix.css", array( 'dashicons' ) );
-	$styles->add( 'media-views',    "/wp-includes/css/media-views$suffix.css", array( 'buttons', 'dashicons', 'wp-mediaelement' ) );
-	$styles->add( 'wp-pointer',     "/wp-includes/css/wp-pointer$suffix.css", array( 'dashicons' ) );
+	$styles->add( 'admin-bar',         "/wp-includes/css/admin-bar$suffix.css", array( 'open-sans', 'dashicons' ) );
+	$styles->add( 'wp-auth-check',     "/wp-includes/css/wp-auth-check$suffix.css", array( 'dashicons' ) );
+	$styles->add( 'editor-buttons',    "/wp-includes/css/editor$suffix.css", array( 'dashicons' ) );
+	$styles->add( 'media-views',       "/wp-includes/css/media-views$suffix.css", array( 'buttons', 'dashicons', 'wp-mediaelement' ) );
+	$styles->add( 'wp-pointer',        "/wp-includes/css/wp-pointer$suffix.css", array( 'dashicons' ) );
+	$styles->add( 'customize-preview', "/wp-includes/css/customize-preview$suffix.css" );
 
 	// External libraries and friends
 	$styles->add( 'imgareaselect',       '/wp-includes/js/imgareaselect/imgareaselect.css', array(), '0.9.8' );
@@ -695,7 +700,7 @@
 	// RTL CSS
 	$rtl_styles = array(
 		// wp-admin
-		'wp-admin', 'install', 'wp-color-picker', 'customize-controls', 'customize-widgets', 'ie', 'login', 'press-this',
+		'wp-admin', 'install', 'wp-color-picker', 'customize-controls', 'customize-widgets', 'customize-nav-menus', 'ie', 'login', 'press-this',
 		// wp-includes
 		'buttons', 'admin-bar', 'wp-auth-check', 'editor-buttons', 'media-views', 'wp-pointer',
 		'wp-jquery-ui-dialog',